// Promise قول دادن

const fetchData = () => {
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      console.log("Fetching Data Complete");
      resolve({ id: 1, message: "Fetching Data Completed ✌️❤️" });
    }, 2000);
  });
};

const parseData = (data) => {
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      let parsedData =
        "Parsed The Data Was Successfully => id: " +
        data.id +
        " And message: " +
        data.message;
      resolve({ parsed: parsedData });
    }, 2000);
  });
};

const showData = (response) => {
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      console.log(response.parsed);
      resolve(response);
    }, 2000);
  });
};

fetchData().then(parseData).then(showData);

// DRY => Dont Repeat Yourself
